#include <xlic/licensing.h>
#include <string.h>

extern "C" const char * xlic_errstr(int code) {
	switch (code) {
		case XLIC_RESULT_SUCCESS: { return "Request succeeded"; }
		case XLIC_RESULT_GENERIC_ERROR: { return "General error occurred while processing request"; }
		case XLIC_RESULT_SERVER_ERROR: { return "Error occurred while communicating with licensing server"; }
		case XLIC_RESULT_DAEMON_ERROR: { return "Error occurred while communicating with licensing daemon"; }
		case XLIC_RESULT_REJECTED: { return "Request rejected by licensing server"; }
		case XLIC_RESULT_INVALIDKEY: { return "Invalid license key"; }
		case XLIC_RESULT_NOLICENSE: { return "License key does not exist"; }
		case XLIC_RESULT_KEYEXISTS: { return "License already registered"; }
		case XLIC_RESULT_UNKNOWN: { return "Unknown error occurred"; }
		case XLIC_RESULT_FOREIGN: { return "Licenses do not belong to this system"; }
	}
	return strerror(code);
}
