#include <xlic/licensing.h>

#include "external_license_list.hpp"

#include <xlic/client.hpp>
#include <xtl/exception.hpp>
#include <memory>

extern "C" int xlic_licenses(const char * socket_filename, xlic_license_list ** list) {
	try {
		auto licenses = std::make_unique<external_license_list>(xlic::client(socket_filename).list_licenses());
		*list = licenses.release();
		return 0;
	} catch (const xlic::client_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xtl::unix_socket_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xlic::result_code & result) {
		return int(result);
	} catch (const std::exception & e) {}
	return -1;
}
