#include <xlic/licensing.h>

#include <xlic/client.hpp>
#include <xtl/exception.hpp>

extern "C" int xlic_unregister_license(const char * socket_filename, const char * key) {
	try {
		xlic::client(socket_filename).unregister_license(key);
		return 0;
	} catch (const xlic::invalid_license_key &) {
		return XLIC_RESULT_INVALIDKEY;
	} catch (const xlic::client_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xtl::unix_socket_exception &) {
		return XLIC_RESULT_DAEMON_ERROR;
	} catch (const xlic::result_code & result) {
		return int(result);
	} catch (const std::exception & e) {}
	return -1;
}
