#ifndef __XLIC_SESSION__
#define __XLIC_SESSION__

#include <xtl/exception.hpp>
#include <xtl/fiber.hpp>
#include <xtl/unix_socket.hpp>

namespace xlic {

class session_exception : public xtl::exception {
public:
	inline session_exception(const char * file, int line, const char * reason)
	: exception(file, line, "%s", reason) {}
};

class worker;

class session {
public:
	session(xlic::worker & worker, xtl::unix_socket && socket);
	session(xlic::session && other) noexcept;
	session & operator=(xlic::session && other) noexcept;
	~session() noexcept;

	inline xtl::unix_socket & socket() noexcept { return m_socket; }

private:
	xlic::worker & m_worker;
	xtl::unix_socket m_socket;
	xtl::fiber m_reader;

	void read_input();
	void write_results();
};

} // namespace xlic

#endif
