#include <xlic/list_licenses.hpp>

#include <xlic/worker.hpp>

namespace xlic {

list_licenses::list_licenses(
	xlic::session * session,
	xlic::worker & worker,
	xlic::request_id request_id
)
: task(session, worker, request_id)
, m_licenses(m_worker.licenses())
{
	m_worker.completed(this);
}

void list_licenses::write_result(xtl::ostream & stream) {
	stream << xlic::packet_size(xlic::packet_header_size + m_licenses.size());
	stream << xlic::packet_type::license_list;
	stream << m_request_id;
	stream << m_licenses;
}
} // namespace xlic
