#ifndef __XTL_CRYPTOSTREAM__
#define __XTL_CRYPTOSTREAM__

#include <xtl/iostream.hpp>
#include <cstddef>
#include <memory>

namespace xtl {

class cryptostream : public xtl::iostream, std::shared_ptr<class cryptostream_impl> {
public:
	explicit cryptostream(xtl::iostream & stream, size_t buffer_size = 8192);

	void set_read_key(const void * buffer, size_t amount);
	void set_write_key(const void * buffer, size_t amount);
	void set_read_iv(const void * buffer, size_t amount);
	void set_write_iv(const void * buffer, size_t amount);

	size_t read(void * buffer, size_t amount) override;
	size_t write(const void * buffer, size_t amount) override;
	size_t flush() override;
};

namespace crypto {

size_t block_size();
size_t key_size();
size_t iv_size();
void randomize(void * buffer, size_t amount);

} // namespace crypto

} // namespace xtl

#endif
