#ifndef __XTL_FIBER__
#define __XTL_FIBER__

#include <xtl/function.hpp>
#include <memory>
#include <cstddef>

namespace xtl {

struct fiber : std::shared_ptr<class fiber_impl> {
	explicit fiber(xtl::function<void()> function, size_t stack_size = 0x10000);
	template<typename callable_type, typename... capture_types>
		explicit fiber(callable_type && callable, capture_types &&... captures);
};

template<typename callable_type, typename... capture_types>
inline fiber::fiber(callable_type && callable, capture_types &&... captures)
: fiber(xtl::function<void()>(std::forward<callable_type>(callable), std::forward<capture_types>(captures)...))
{}

void yield();

} // namespace xtl

#endif
