#ifndef __XTL_FILE_DESCRIPTOR__
#define __XTL_FILE_DESCRIPTOR__

#include <utility>
#include <xtl/shims.hpp>

namespace xtl {

class file_descriptor {
public:
	enum { invalid = -1 };

	constexpr file_descriptor(int value) noexcept;
	file_descriptor(xtl::file_descriptor && other) noexcept;
	file_descriptor & operator=(xtl::file_descriptor && other) noexcept;
	~file_descriptor() noexcept;

	int value() const noexcept;
	explicit operator bool() const noexcept;

private:
	int m_value;
};

inline constexpr file_descriptor::file_descriptor(int value) noexcept
: m_value(value) {}

inline file_descriptor::file_descriptor(xtl::file_descriptor && other) noexcept
: m_value(std::exchange(other.m_value, invalid)) {}

inline int file_descriptor::value() const noexcept {
	return m_value;
}

inline file_descriptor::operator bool() const noexcept {
	return m_value != invalid;
}

} // namespace xtl

#endif
