#ifndef __XTL_FILESTREAM__
#define __XTL_FILESTREAM__

#include <xtl/filemode.hpp>
#include <xtl/iostream.hpp>

#include <cstddef>
#include <string>
#include <memory>

namespace xtl {

struct filestream : public xtl::iostream, std::shared_ptr<class filestream_impl> {
	explicit filestream(const std::string & filename, xtl::filemode mode = xtl::filemode::readonly);

	size_t size() const;
	void chmod(int mode);
	void truncate(size_t size = 0);

	size_t read(void * buffer, size_t amount) override;
	size_t write(const void * buffer, size_t amount) override;
	size_t flush() override;
};

} // namespace xtl

#endif
