#ifndef __XTL_HASH_METHOD__
#define __XTL_HASH_METHOD__

#include <cstddef>
#include <cstdint>
#include <string>
#include <type_traits>

namespace xtl {

struct hash_method {
	virtual hash_method & append(const void * buffer, size_t amount) = 0;

	template<typename T> typename std::enable_if<std::is_pod<T>::value, hash_method &>::type operator+=(const T & value);
};

template<typename T>
inline typename std::enable_if<std::is_pod<T>::value, hash_method &>::type hash_method::operator+=(const T & value) {
	return append(&value, sizeof(value));
}

} // namespace xtl

#endif
