#ifndef __XTL_ISTREAM__
#define __XTL_ISTREAM__

#include <cstddef>
#include <cstdint>
#include <string>
#include <type_traits>

namespace xtl {

class istream {
public:
	virtual size_t read(void * buffer, size_t amount) = 0;

	template<typename T> typename std::enable_if<std::is_pod<T>::value, istream &>::type operator>>(T & value);
};

xtl::istream & read(xtl::istream & istream, void * buffer, size_t amount);

template<typename T>
inline typename std::enable_if<std::is_pod<T>::value, istream &>::type istream::operator>>(T & value) {
	return xtl::read(*this, &value, sizeof(value));
}

} // namespace xtl

#endif
