#ifndef __XTL_OS__
#define __XTL_OS__

#include <vector>
#include <string>

namespace xtl {

class mac_address {
public:
	inline void * value() noexcept { return m_value; }
	inline const void * value() const noexcept { return m_value; }
	inline size_t size() const noexcept { return sizeof(m_value); }

	bool operator<(const xtl::mac_address & other) const noexcept;
	bool operator==(const xtl::mac_address & other) const noexcept;

private:
	uint8_t m_value[6];
};

std::string to_string(const xtl::mac_address & mac_address);

struct network_interface {
	std::string name;
	//~ std::vector<std::string> addresses;
	xtl::mac_address mac_address;
};

namespace os {

	size_t processor_count();
	size_t page_size();
	size_t stack_size();
	std::vector<xtl::network_interface> interfaces();

} // namespace os

} // namespace xtl

#endif
