#ifndef __XTL_OSTREAM__
#define __XTL_OSTREAM__

#include <cstddef>
#include <cstdint>
#include <string>
#include <type_traits>

namespace xtl {

class ostream {
public:
	virtual size_t write(const void * buffer, size_t amount) = 0;
	virtual size_t flush() = 0;

	template<typename T> typename std::enable_if<std::is_pod<T>::value, ostream &>::type operator<<(const T & value);

};

xtl::ostream & write(xtl::ostream & stream, const void * buffer, size_t amount);

template<typename T>
inline typename std::enable_if<std::is_pod<T>::value, ostream &>::type ostream::operator<<(const T & value) {
	return xtl::write(*this, &value, sizeof(value));
}

} // namespace xtl

#endif
