#ifndef __XTL_SCHEDULER__
#define __XTL_SCHEDULER__

#include <xtl/file_descriptor.hpp>
#include <xtl/function.hpp>
#include <cstddef>

namespace xtl {

struct scheduler {
	static void monitor(const xtl::file_descriptor & fd);
	static void release(const xtl::file_descriptor & fd);
	static void set_timeout(const xtl::file_descriptor & fd, size_t timeout_ms);
	static void wait_for(const xtl::file_descriptor & fd);
	static void * create_fiber(xtl::function<void()> && function, size_t stack_size);
	static void destroy_fiber(void * fiber);
};

} // namespace xtl

#endif
