#ifndef __XTL__STACK__
#define __XTL__STACK__

#include <cstddef>

namespace xtl {

class stack {
public:
	stack() noexcept;
	explicit stack(size_t size);
	stack(stack &&) noexcept;
	stack & operator=(stack &&) noexcept;
	~stack() noexcept;

	void * get() const noexcept;
	size_t size() const noexcept;

private:
	size_t m_size;
	void * m_base;
};

} // namespace xtl

namespace xtl {

inline stack::stack() noexcept : m_size(0), m_base(nullptr) {}

inline void * stack::get() const noexcept {
	return m_base;
}

inline size_t stack::size() const noexcept {
	return m_size;
}

} // namespace xtl

#endif
