#ifndef __XTL_THREAD__
#define __XTL_THREAD__

#include <xtl/function.hpp>
#include <memory>

namespace xtl {

struct thread : std::shared_ptr<class thread_impl> {
	explicit thread(xtl::function<void()> function);
	template<typename callable_type, typename... capture_types>
		explicit thread(callable_type && callable, capture_types &&... captures);
};

template<typename callable_type, typename... capture_types>
inline thread::thread(callable_type && callable, capture_types &&... captures)
: thread(xtl::function<void()>(std::forward<callable_type>(callable), std::forward<capture_types>(captures)...))
{}

void yield();

} // namespace xtl

#endif
