#ifndef __XTL_UNIX_SOCKET__
#define __XTL_UNIX_SOCKET__

#include <xtl/exception.hpp>
#include <xtl/file_descriptor.hpp>
#include <xtl/iostream.hpp>
#include <cerrno>
#include <cstddef>
#include <string>
#include <memory>

namespace xtl {

class unix_socket_exception : public xtl::system_exception {
public:
	inline unix_socket_exception(const char * file, int line, int code = errno)
	: system_exception(file, line, code) {}
};

struct unix_socket : public xtl::iostream, std::shared_ptr<class unix_socket_impl> {
	explicit unix_socket(const std::string & filename);
	explicit unix_socket(xtl::file_descriptor fd);

	void set_timeout(size_t timeout_ms);

	size_t read(void * buffer, size_t amount) override;
	size_t write(const void * buffer, size_t amount) override;
	size_t flush() override;
};

} // namespace xtl

#endif
