#ifndef __XTL_VERIFY_METHOD__
#define __XTL_VERIFY_METHOD__

#include <cstddef>
#include <cstdint>
#include <string>
#include <type_traits>

namespace xtl {

struct verify_method {
	virtual verify_method & append(const void * buffer, size_t amount) = 0;

	template<typename T> typename std::enable_if<std::is_pod<T>::value, verify_method &>::type operator+=(const T & value);
};

template<typename T>
inline typename std::enable_if<std::is_pod<T>::value, verify_method &>::type verify_method::operator+=(const T & value) {
	return append(&value, sizeof(value));
}

} // namespace xtl

#endif
