#include <xtl/exception.hpp>

#include <cstdarg>
#include <cstring>

namespace xtl {

exception::exception(const char * file, int line, const char * format, ...) {
	va_list ap;
	const size_t prefix_length = snprintf(nullptr, 0, "%s[%d]: ", file, line);
	va_start(ap, format);
	const size_t args_length =  vsnprintf(nullptr, 0, format, ap);
	va_end(ap);
	m_what.resize(prefix_length + args_length);
	snprintf(&m_what[0], prefix_length + 1, "%s[%d]: ", file, line);
	va_start(ap, format);
	vsnprintf(&m_what[prefix_length], args_length + 1, format, ap);
	va_end(ap);
}

system_exception::system_exception(const char * file, int line, int code)
: exception(file, line, "%s", strerror_l(code, LC_GLOBAL_LOCALE)) {}

} // namespace xtl
