#include <xtl/file_descriptor.hpp>

#include <unistd.h>

namespace xtl {

file_descriptor & file_descriptor::operator=(file_descriptor && other) noexcept {
	if (m_value >= 0) {
		::close(m_value);
	}
	m_value = std::exchange(other.m_value, invalid);
	return *this;
}


file_descriptor::~file_descriptor() noexcept {
	if (m_value >= 0) {
		::close(m_value);
	}
}

} // namespace xtl
